#define CCRF_3_IOCFG3                   0x0000
#define CCRF_3_IOCFG2                   0x0001
#define CCRF_3_IOCFG1                   0x0002
#define CCRF_3_IOCFG0                   0x0003
#define CCRF_3_SYNC3                    0x0004
#define CCRF_3_SYNC2                    0x0005
#define CCRF_3_SYNC1                    0x0006
#define CCRF_3_SYNC0                    0x0007
#define CCRF_3_SYNC_CFG1                0x0008
#define CCRF_3_SYNC_CFG0                0x0009
#define CCRF_3_DEVIATION_M              0x000A
#define CCRF_3_MODCFG_DEV_E             0x000B
#define CCRF_3_DCFILT_CFG               0x000C
#define CCRF_3_PREAMBLE_CFG1            0x000D
#define CCRF_3_PREAMBLE_CFG0            0x000E
#define CCRF_3_FREQ_IF_CFG              0x000F
#define CCRF_3_IQIC                     0x0010
#define CCRF_3_CHAN_BW                  0x0011
#define CCRF_3_MDMCFG1                  0x0012
#define CCRF_3_MDMCFG0                  0x0013
#define CCRF_3_SYMBOL_RATE2             0x0014
#define CCRF_3_SYMBOL_RATE1             0x0015
#define CCRF_3_SYMBOL_RATE0             0x0016
#define CCRF_3_AGC_REF                  0x0017
#define CCRF_3_AGC_CS_THR               0x0018
#define CCRF_3_AGC_GAIN_ADJUST          0x0019
#define CCRF_3_AGC_CFG3                 0x001A
#define CCRF_3_AGC_CFG2                 0x001B
#define CCRF_3_AGC_CFG1                 0x001C
#define CCRF_3_AGC_CFG0                 0x001D
#define CCRF_3_FIFO_CFG                 0x001E
#define CCRF_3_DEV_ADDR                 0x001F
#define CCRF_3_SETTLING_CFG             0x0020
#define CCRF_3_FS_CFG                   0x0021
#define CCRF_3_WOR_CFG1                 0x0022
#define CCRF_3_WOR_CFG0                 0x0023
#define CCRF_3_WOR_EVENT0_MSB           0x0024
#define CCRF_3_WOR_EVENT0_LSB           0x0025
#define CCRF_3_PKT_CFG2                 0x0026
#define CCRF_3_PKT_CFG1                 0x0027
#define CCRF_3_PKT_CFG0                 0x0028
#define CCRF_3_RFEND_CFG1               0x0029
#define CCRF_3_RFEND_CFG0               0x002A
#define CCRF_3_PA_CFG2                  0x002B
#define CCRF_3_PA_CFG1                  0x002C
#define CCRF_3_PA_CFG0                  0x002D
#define CCRF_3_PKT_LEN                  0x002E

/* Extended Configuration Registers */
#define CCRF_3_IF_MIX_CFG               0x2F00
#define CCRF_3_FREQOFF_CFG              0x2F01
#define CCRF_3_TOC_CFG                  0x2F02
#define CCRF_3_MARC_SPARE               0x2F03
#define CCRF_3_ECG_CFG                  0x2F04
#define CCRF_3_CFM_DATA_CFG             0x2F05
#define CCRF_3_EXT_CTRL                 0x2F06
#define CCRF_3_RCCAL_FINE               0x2F07
#define CCRF_3_RCCAL_COARSE             0x2F08
#define CCRF_3_RCCAL_OFFSET             0x2F09
#define CCRF_3_FREQOFF1                 0x2F0A
#define CCRF_3_FREQOFF0                 0x2F0B
#define CCRF_3_FREQ2                    0x2F0C
#define CCRF_3_FREQ1                    0x2F0D
#define CCRF_3_FREQ0                    0x2F0E
#define CCRF_3_IF_ADC2                  0x2F0F
#define CCRF_3_IF_ADC1                  0x2F10
#define CCRF_3_IF_ADC0                  0x2F11
#define CCRF_3_FS_DIG1                  0x2F12
#define CCRF_3_FS_DIG0                  0x2F13
#define CCRF_3_FS_CAL3                  0x2F14
#define CCRF_3_FS_CAL2                  0x2F15
#define CCRF_3_FS_CAL1                  0x2F16
#define CCRF_3_FS_CAL0                  0x2F17
#define CCRF_3_FS_CHP                   0x2F18
#define CCRF_3_FS_DIVTWO                0x2F19
#define CCRF_3_FS_DSM1                  0x2F1A
#define CCRF_3_FS_DSM0                  0x2F1B
#define CCRF_3_FS_DVC1                  0x2F1C
#define CCRF_3_FS_DVC0                  0x2F1D
#define CCRF_3_FS_LBI                   0x2F1E
#define CCRF_3_FS_PFD                   0x2F1F
#define CCRF_3_FS_PRE                   0x2F20
#define CCRF_3_FS_REG_DIV_CML           0x2F21
#define CCRF_3_FS_SPARE                 0x2F22
#define CCRF_3_FS_VCO4                  0x2F23
#define CCRF_3_FS_VCO3                  0x2F24
#define CCRF_3_FS_VCO2                  0x2F25
#define CCRF_3_FS_VCO1                  0x2F26
#define CCRF_3_FS_VCO0                  0x2F27
#define CCRF_3_GBIAS6                   0x2F28
#define CCRF_3_GBIAS5                   0x2F29
#define CCRF_3_GBIAS4                   0x2F2A
#define CCRF_3_GBIAS3                   0x2F2B
#define CCRF_3_GBIAS2                   0x2F2C
#define CCRF_3_GBIAS1                   0x2F2D
#define CCRF_3_GBIAS0                   0x2F2E
#define CCRF_3_IFAMP                    0x2F2F
#define CCRF_3_LNA                      0x2F30
#define CCRF_3_RXMIX                    0x2F31
#define CCRF_3_XOSC5                    0x2F32
#define CCRF_3_XOSC4                    0x2F33
#define CCRF_3_XOSC3                    0x2F34
#define CCRF_3_XOSC2                    0x2F35
#define CCRF_3_XOSC1                    0x2F36
#define CCRF_3_XOSC0                    0x2F37
#define CCRF_3_ANALOG_SPARE             0x2F38
#define CCRF_3_PA_CFG3                  0x2F39
#define CCRF_3_IRQ0M                    0x2F3F
#define CCRF_3_IRQ0F                    0x2F40

/* Status Registers */
#define CCRF_3_WOR_TIME1                0x2F64
#define CCRF_3_WOR_TIME0                0x2F65
#define CCRF_3_WOR_CAPTURE1             0x2F66
#define CCRF_3_WOR_CAPTURE0             0x2F67
#define CCRF_3_BIST                     0x2F68
#define CCRF_3_DCFILTOFFSET_I1          0x2F69
#define CCRF_3_DCFILTOFFSET_I0          0x2F6A
#define CCRF_3_DCFILTOFFSET_Q1          0x2F6B
#define CCRF_3_DCFILTOFFSET_Q0          0x2F6C
#define CCRF_3_IQIE_I1                  0x2F6D
#define CCRF_3_IQIE_I0                  0x2F6E
#define CCRF_3_IQIE_Q1                  0x2F6F
#define CCRF_3_IQIE_Q0                  0x2F70
#define CCRF_3_RSSI1                    0x2F71
#define CCRF_3_RSSI0                    0x2F72
#define CCRF_3_MARCSTATE                0x2F73
#define CCRF_3_LQI_VAL                  0x2F74
#define CCRF_3_PQT_SYNC_ERR             0x2F75
#define CCRF_3_DEM_STATUS               0x2F76
#define CCRF_3_FREQOFF_EST1             0x2F77
#define CCRF_3_FREQOFF_EST0             0x2F78
#define CCRF_3_AGC_GAIN3                0x2F79
#define CCRF_3_AGC_GAIN2                0x2F7A
#define CCRF_3_AGC_GAIN1                0x2F7B
#define CCRF_3_AGC_GAIN0                0x2F7C
#define CCRF_3_CFM_RX_DATA_OUT          0x2F7D
#define CCRF_3_CFM_TX_DATA_IN           0x2F7E
#define CCRF_3_ASK_SOFT_RX_DATA         0x2F7F
#define CCRF_3_RNDGEN                   0x2F80
#define CCRF_3_MAGN2                    0x2F81
#define CCRF_3_MAGN1                    0x2F82
#define CCRF_3_MAGN0                    0x2F83
#define CCRF_3_ANG1                     0x2F84
#define CCRF_3_ANG0                     0x2F85
#define CCRF_3_CHFILT_I2                0x2F86
#define CCRF_3_CHFILT_I1                0x2F87
#define CCRF_3_CHFILT_I0                0x2F88
#define CCRF_3_CHFILT_Q2                0x2F89
#define CCRF_3_CHFILT_Q1                0x2F8A
#define CCRF_3_CHFILT_Q0                0x2F8B
#define CCRF_3_GPIO_STATUS              0x2F8C
#define CCRF_3_FSCAL_CTRL               0x2F8D
#define CCRF_3_PHASE_ADJUST             0x2F8E
#define CCRF_3_PARTNUMBER               0x2F8F
#define CCRF_3_PARTVERSION              0x2F90
#define CCRF_3_SERIAL_STATUS            0x2F91
#define CCRF_3_MODEM_STATUS1            0x2F92
#define CCRF_3_MODEM_STATUS0            0x2F93
#define CCRF_3_MARC_STATUS1             0x2F94
#define CCRF_3_MARC_STATUS0             0x2F95
#define CCRF_3_PA_IFAMP_TEST            0x2F96
#define CCRF_3_FSRF_TEST                0x2F97
#define CCRF_3_PRE_TEST                 0x2F98
#define CCRF_3_PRE_OVR                  0x2F99
#define CCRF_3_ADC_TEST                 0x2F9A
#define CCRF_3_DVC_TEST                 0x2F9B
#define CCRF_3_ATEST                    0x2F9C
#define CCRF_3_ATEST_LVDS               0x2F9D
#define CCRF_3_ATEST_MODE               0x2F9E
#define CCRF_3_XOSC_TEST1               0x2F9F
#define CCRF_3_XOSC_TEST0               0x2FA0

#define CCRF_3_RXFIRST                  0x2FD2
#define CCRF_3_TXFIRST                  0x2FD3
#define CCRF_3_RXLAST                   0x2FD4
#define CCRF_3_TXLAST                   0x2FD5
#define CCRF_3_NUM_TXBYTES              0x2FD6  /* Number of bytes in TXFIFO */
#define CCRF_3_NUM_RXBYTES              0x2FD7  /* Number of bytes in RXFIFO */
#define CCRF_3_FIFO_NUM_TXBYTES         0x2FD8
#define CCRF_3_FIFO_NUM_RXBYTES         0x2FD9


/* DATA FIFO Access */
#define CCRF_3_SINGLE_TXFIFO            0x003F      /*  TXFIFO  - Single accecss to Transmit FIFO */
#define CCRF_3_BURST_TXFIFO             0x007F      /*  TXFIFO  - Burst accecss to Transmit FIFO  */
#define CCRF_3_SINGLE_RXFIFO            0x00BF      /*  RXFIFO  - Single accecss to Receive FIFO  */
#define CCRF_3_BURST_RXFIFO             0x00FF      /*  RXFIFO  - Busrrst ccecss to Receive FIFO  */

#define CCRF_3_LQI_CRC_OK_BM            0x80
#define CCRF_3_LQI_EST_BM               0x7F



/* Command strobe registers */
#define CCRF_3_SRES                     0x30      /*  SRES    - Reset chip. */
#define CCRF_3_SFSTXON                  0x31      /*  SFSTXON - Enable and calibrate frequency synthesizer. */
#define CCRF_3_SXOFF                    0x32      /*  SXOFF   - Turn off crystal oscillator. */
#define CCRF_3_SCAL                     0x33      /*  SCAL    - Calibrate frequency synthesizer and turn it off. */
#define CCRF_3_SRX                      0x34      /*  SRX     - Enable RX. Perform calibration if enabled. */
#define CCRF_3_STX                      0x35      /*  STX     - Enable TX. If in RX state, only enable TX if CCA passes. */
#define CCRF_3_SIDLE                    0x36      /*  SIDLE   - Exit RX / TX, turn off frequency synthesizer. */
#define CCRF_3_SWOR                     0x38      /*  SWOR    - Start automatic RX polling sequence (Wake-on-Radio) */
#define CCRF_3_SPWD                     0x39      /*  SPWD    - Enter power down mode when CSn goes high. */
#define CCRF_3_SFRX                     0x3A      /*  SFRX    - Flush the RX FIFO buffer. */
#define CCRF_3_SFTX                     0x3B      /*  SFTX    - Flush the TX FIFO buffer. */
#define CCRF_3_SWORRST                  0x3C      /*  SWORRST - Reset real time clock. */
#define CCRF_3_SNOP                     0x3D      /*  SNOP    - No operation. Returns status byte. */
#define CCRF_3_AFC                      0x37      /*  AFC     - Automatic Frequency Correction */

/* Chip states returned in status byte */
#define CCRF_3_STATE_IDLE               0x00
#define CCRF_3_STATE_RX                 0x10
#define CCRF_3_STATE_TX                 0x20
#define CCRF_3_STATE_FSTXON             0x30
#define CCRF_3_STATE_CALIBRATE          0x40
#define CCRF_3_STATE_SETTLING           0x50
#define CCRF_3_STATE_RXFIFO_ERROR       0x60
#define CCRF_3_STATE_TXFIFO_ERROR       0x70